#include "Finch.h"
#include <ch.h>


EXPORTCH int Fin_Init_chdl(void *varg) {
    int retval;
    retval = Fin_Init();
    return retval;
}
EXPORTCH int Fin_Exit_chdl(void *varg) {
    int retval;
    retval = Fin_Exit();
    return retval;
}

EXPORTCH int Fin_Motor_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    int tenth;
    int left;
    int right;
    int retval;

    Ch_VaStart(interp, ap, varg);
    tenth = Ch_VaArg(interp, ap, int);
    left = Ch_VaArg(interp, ap, int);
    right = Ch_VaArg(interp, ap, int);
    retval = Fin_Motor(tenth, left, right);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH int Fin_Move_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    int tenth;
    int left;
    int right;
    int retval;

    Ch_VaStart(interp, ap, varg);
    tenth = Ch_VaArg(interp, ap, int);
    left = Ch_VaArg(interp, ap, int);
    right = Ch_VaArg(interp, ap, int);
    retval = Fin_Move(tenth, left, right);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH int Fin_Speed_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    int *left;
    int *right;
    int retval;

    Ch_VaStart(interp, ap, varg);
    left = Ch_VaArg(interp, ap, int *);
    right = Ch_VaArg(interp, ap, int *);
    retval = Fin_Speed(left, right);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH int Fin_LED_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    int red;
    int green;
    int blue;
    int retval;

    Ch_VaStart(interp, ap, varg);
    red = Ch_VaArg(interp, ap, int);
    green = Ch_VaArg(interp, ap, int);
    blue = Ch_VaArg(interp, ap, int);
    retval = Fin_LED(red, green, blue);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH int Fin_Buzzer_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    int msec;
    int freq;
    int retval;

    Ch_VaStart(interp, ap, varg);
    msec = Ch_VaArg(interp, ap, int);
    freq = Ch_VaArg(interp, ap, int);
    retval = Fin_Buzzer(msec, freq);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH int Fin_Lights_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    int *left;
    int *right;
    int retval;

    Ch_VaStart(interp, ap, varg);
    left = Ch_VaArg(interp, ap, int *);
    right = Ch_VaArg(interp, ap, int *);
    retval = Fin_Lights(left, right);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH int Fin_Obstacle_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    int *left;
    int *right;
    int retval;

    Ch_VaStart(interp, ap, varg);
    left = Ch_VaArg(interp, ap, int *);
    right = Ch_VaArg(interp, ap, int *);
    retval = Fin_Obstacle(left, right);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH int Fin_Temp_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    float *temp;
    int retval;

    Ch_VaStart(interp, ap, varg);
    temp = Ch_VaArg(interp, ap, float *);
    retval = Fin_Temp(temp);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH int Fin_Accel_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    float *x;
    float *y;
    float *z;
    int *tap;
    int *shake;
    int retval;

    Ch_VaStart(interp, ap, varg);
    x = Ch_VaArg(interp, ap, float *);
    y = Ch_VaArg(interp, ap, float *);
    z = Ch_VaArg(interp, ap, float *);
    tap = Ch_VaArg(interp, ap, int *);
    shake = Ch_VaArg(interp, ap, int *);
    retval = Fin_Accel(x, y, z, tap, shake);
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH char *CheckForInput_chdl(void *varg) {
    char *retval;
    retval = CheckForInput();
    return retval;
}

EXPORTCH int Fin_Cmnd_chdl(void *varg){
    ChInterp_t interp;
    ChVaList_t ap;
    int flag;
    char cmnd;
    unsigned char *buffer;
    int retval;

    Ch_VaStart(interp, ap, varg);
    flag = Ch_VaArg(interp, ap, int);
    cmnd = Ch_VaArg(interp, ap, char);
    buffer = Ch_VaArg(interp, ap, unsigned char *);
    retval = Fin_Cmnd(flag, cmnd, buffer);
    Ch_VaEnd(interp, ap);
    return retval;
}

#ifdef _LINUX_
EXPORTCH int kbhit_chdl(void *varg) {
    int retval;
    retval = kbhit();
    return retval;
}

EXPORTCH void KeyThread_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    void *arg;
    
    Ch_VaStart(interp, ap, varg);
    arg = Ch_VaArg(interp, ap, void *);
    KeyThread(arg);
    Ch_VaEnd(interp, ap);
    
    return;
}
#endif

